



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>mysql from dual插入实现不插入重复记录</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">mysql from dual插入实现不插入重复记录</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 14:30:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在mysql中插入一或者多条记录的时候，要求某个字段的值唯一，但是该字段没有添加唯一性索引，可用from dual解决。</p>
<p>select * from (<br />select '2015080109' a,2 b,4 c,5 d from dual<br />union&nbsp;<br />select '2015080106' a,2 b,4 c,5 d from dual<br />) a where not exists (select lottery_no from user b where a.a = b.lottery_no)</p>
<p>INSERT INTO user&nbsp;&nbsp;(id, no,add_time,remark)<br />select * from (<br />SELECT 1 id, 1 no, NOW() add_time,'1,2,3,1,2' remark FROM DUAL&nbsp;<br />UNION ALL&nbsp;<br />SELECT 1 no, 2 no, NOW() add_time,'1,2,3,1,2' remark&nbsp;FROM DUAL&nbsp;<br />UNION ALL&nbsp;<br />SELECT 1 no, 3 no, NOW() add_time,'1,2,3,1,2' remark&nbsp;FROM DUAL&nbsp;<br />) a where not exists (select no from user b where a.no = b.no)</p>
<p>上述是实现user表的no字段不重复，插入三条记录。</p>
<p>下面是mybatis批量写入no字段不重复的实现语句。</p>
<p>INSERT INTO user (id, no,add_time,result)<br />select * from (<br />&lt;foreach collection="list" item="obj" separator=" UNION ALL " &gt;<br />SELECT #{obj.id} id, #{obj.no} no, #{obj.addTime} add_time,#{obj.remark} remark FROM DUAL<br />&lt;/foreach&gt;<br />) a where not exists (select no from user b where a.no = b.no)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdp417q.html">Node&period;js在Chrome进行调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ly408.html">转载《Android LayoutInflater详解》</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jddzw9.html">Web API接口设计经验总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx51kq.html">mydumper 安装报错处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oeo5x9.html">Solve&colon; Your project references the latest version of Entity Framework &lpar;for MySQL&rpar; in Visual Studio 2013</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ezr29.html">百度文库，linux下安装oracle客户端</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqly3469.html">【HTML5】Web存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vpxk48.html">JDBC学习总结&lpar;三&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv3j0zq.html">ASP&period;NET Cache</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1rddr9.html">Gradle使用手册（二）：项目结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdwjwm8.html">matlab vs python</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zexjz9.html">BZOJ 1024 SCOI 2009 生日快乐 深搜</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kmrp69.html">TextBox控件只允许输入出生日期，并验证年龄不得小于18岁</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kzem69.html">SVN 的revert操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meel0pq.html">【设计模式】Template Method模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj3nxpq.html">TP-LINK 路由器怎么设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1oonjq.html">Java I&sol;O---Properties类（持久化键值对）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z2y709.html">shell编程之环境变量配置文件&lpar;4&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yz7eg8.html">dede织梦 arclist标签完美支持currentstyle属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11krxq.html">JavaScript基础视频教程总结（121-130章）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90r0wg39.html">第三百九十三节，Django&plus;Xadmin打造上线标准的在线教育平台&mdash;Xadmin后台进阶开发配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvyk538.html">RDP 数据库简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy711d9.html">swoole Tcp</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5lg74q.html">jar各个版本号的意义</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy7o739.html">使用 wondershaper 在 Linux 中限制网络带宽使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvyv538.html">&lbrack;Java&rsqb; Apache Ant 构建基础教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjzjv79.html">C语言实现mq收发数据的函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw5wyy8.html">【死磕jeesite源码】Jeesite配置定时任务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvyvpl8.html">File &sol;hbase&sol;&period;tmp&sol;hbase&period;version could only be replicated to 0 nodes instead of minReplication &lpar;&equals;1&rpar;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o1ewe8.html">linux zendOptimizer安装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
